<% @Language=VBScript %>
<!-- #include file="routines.vbs" -->
<%
    Sub SetVal(sect,name,v)
        If IsObject(sect(name)) Then
            sect(name)(1) = v
        Else
            sect.Add name, cfg.CreateRecord
            sect(name).Add "", v
        End If
    End Sub
    
    Set cfg = Server.CreateObject("newObjects.utilctls.ConfigFile")
    Dim app, defaults
    
    If fileApp = "" Then
        ' Read default
        Set app = cfg.Read(Server.MapPath("defaults/alp.application"))
        fileApp = pathFor & "alp.application"
        dirApp = pathFor
        cfg.Write fileApp,app
    Else
        Set app = cfg.Read(fileApp)
    End If 
    
    Set defaults = cfg.Read(Server.MapPath("defaults.app"))
    
    ' Check consistency
    If Not IsObject(app("APPLICATION")) Then
        app.Add "APPLICATION", cfg.CreateSection
    End If
    If Not IsObject(app("APPLICATION")("Options")) Then
        app("APPLICATION").Add "Options", cfg.CreateSection
    End If
    
    Set opts = app("APPLICATION")("Options")
    
    Dim reqALPFrame,reqAPPID
    reqALPFrame = CLng(opts("RequireALPFrame"))
    If Not IsObject(opts("RequireALPFrame")) Then reqALPFrame = Empty
    reqAPPID = CStr(opts("RequireAppId"))

    Dim n, message, str, bShowMessageOnly, Module, ext
    message = ""
    bShowMessageOnly = False
    If Request("Update").Count > 0 Then
        If Request("ReqALPFrame").Count > 0 Then
            SetVal opts, "RequireALPFrame", CLng(102)
            reqALPFrame = 102
        Else
            If IsObject(opts("RequireALPFrame")) Then opts.Remove "RequireALPFrame"
            reqALPFrame = Empty
        End If
        
        If Request("ReqAPPID") <> "" Then
            SetVal opts, "RequireAppId", CStr(Request("ReqAPPID"))
            reqAPPID = CStr(Request("ReqAPPID"))
        Else
            If IsObject(opts("RequireAppId")) Then opts.Remove "RequireAppId"
            reqAPPID = Empty
        End If
        cfg.Write fileApp, app
        bShowMessageOnly = False
    Else
        bShowMessageOnly = False
    End IF
    
%>
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="styles.css">
<title>ALP Settings</title>
</head>

<body topmargin="0" leftmargin="0">

<table border="0" width="100%" cellspacing="0">
  <!-- #include file="head.inc" -->
  <tr>
    <td width="100%">
        <H4>Current directory</H4>
        <BLOCKQUOTE>
            <%= pathFor %><BR>
            <A HREF="app.asp?Path=<%= pathFor %>">Back to application settings</A>
        </BLOCKQUOTE>
        <% If bShowMessageOnly Then %>
            <I><B><%= message %></B></I>
        <% Else %>
            <DIV ALIGN="CENTER">
            <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
                <INPUT TYPE="HIDDEN" NAME="Path" VALUE="<%= pathFor %>">
                
                <DIV ALIGN="CENTER">
                <TABLE>
                    <TR>
                        <TD>Require ALPFrame browser
                        <A HREF="javascript: void window.open('help/default.asp?Page=sec.htm&Mark=ReqALPFrame')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                        </TD>
                        <TD>
                        <INPUT TYPE="CHECKBOX" NAME="ReqALPFrame" VALUE="On" <%= Checked(reqALPFrame) %>></TD>
                    </TR>
                    <TR>
                        <TD>Requires Application ID
                        <A HREF="javascript: void window.open('help/default.asp?Page=sec.htm&Mark=ReqAPPID')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                        </TD>
                        <TD>
                        <INPUT TYPE="TEXT" NAME="ReqAPPID" VALUE="<%= reqAppId %>">
                        </TD>
                    </TR>
                </TABLE>
                <INPUT TYPE="SUBMIT" NAME="Update" VALUE="Update">
                </DIV>
            </FORM>
            
            <HR WIDTH="80%">
                <H4>More security options</H4>
                <TABLE WIDTH="80%"><TR><TD>
                To enable unattended code execution prevention you must create/edit directory options
                for the entire or the relevant parts of the application and enable that option in the directory
                settings. (The directory settings are accessible through the main screen)
                </TD></TR></TABLE>
            </DIV>
        <% End If %>
    </td>
  </tr>
</table>

</body>

</html>
